% pd_cro.in translated to colog by M. Bezem, Spring 2013.  
% + minor mods by me, JRF.
%  Notice that there are about 31^24 possible initial antecedents for last rule.
%  This theory provides a good speed test for case progress.

% colinear, some line U, conclusion Desargue
l(U,U),i(bc,U),i(ac,U),i(ab,U) => goal.   

true => i(a1,b2c2),i(b1,a2c2),i(c1,a2b2),
  i(a1,a1b1), i(b1,a1b1), i(a2,a2b2), i(b2,a2b2),
  i(a1,a1c1), i(c1,a1c1), i(a2,a2c2), i(c2,a2c2),
  i(c1,b1c1), i(b1,b1c1), i(c2,b2c2), i(b2,b2c2),
  i(o,oa), i(o,ob), i(o,oc), i(a1,oa),
  i(a2,oa), i(b1,ob), i(b2,ob), i(c1,oc), i(c2,oc),
  i(bc,b1c1), i(bc,b2c2), i(ac,a1c1), i(ac,a2c2),
  i(ab,a1b1), i(ab,a2b2).

i(a1,L),i(b1,L),i(c1,L) => false.  % points not colinear
i(a2,L),i(b2,L),i(c2,L) => false.

p(a2,a1)=>false.      % points not equal
p(b2,b1)=>false. 
p(c2,c1)=>false.

l(b1c1,b2c2)=>false.  % lines not equal
l(a1c1,a2c2)=>false. 
l(a1b1,a2b2)=>false.

i(P,L) => p(P,P).     % incident point P on line L

p(P,Q) => p(Q,P).
p(P,Q),p(Q,R) => p(P,R).

i(P,L) => l(L,L).     % incident point P on line L
l(L,M) => l(M,L).
l(L,M),l(M,N) => l(L,N).

p(P,Q),i(Q,L) => i(P,L).
i(P,L),l(L,M) => i(P,M).
i(P,L),i(P,M),i(Q,L),i(Q,M) => p(P,Q) | l(L,M).

p(P,P),p(Q,Q) => i(P,L),i(Q,L).
l(L,L),l(M,M) => i(P,L),i(P,M).   

% Axiom Pappus
i(A,L),i(B,L),i(C,L),i(D,M),i(E,M),i(F,M),          
i(B,N),i(F,N),i(G,N),i(C,O),i(E,O),i(G,O),          
i(B,P),i(D,P),i(H,P),i(A,Q),i(E,Q),i(H,Q),         
i(C,R),i(D,R),i(I,R),i(A,S),i(F,S),i(I,S)       
=> l(N,O) | l(P,Q) | l(R,S) |              % degenerate cases 
   l(T,T),i(G,T),i(H,T),i(I,T).            % new incident line 


